module Day2.Part1 (
parseGameList,
readGame,
playGames,
day2_1
) where

import Day2.Shared

parseGameList :: String -> [Game]
parseGameList = map readGame . lines

readGame :: String -> Game
readGame [x, ' ', y] = Game (opponent x, me y)
  where
    opponent 'A' = Rock
    opponent 'B' = Paper
    opponent 'C' = Scissors
    opponent _ = error $ "unknown opponent shape: " ++ [x]
    me 'X' = Rock
    me 'Y' = Paper
    me 'Z' = Scissors
    me _ = error $ "unknown me shape: " ++ [x]
readGame xs = error $ "readGame not implemented for " ++ xs

playGames :: [Game] -> Score
playGames = foldMap play

day2_1 :: String -> Score
day2_1 = playGames . parseGameList

